#ifndef CLIENT_H
#define CLIENT_H

#include <QObject>
#include <QWindow>

#include "weston-desktop-shell-client-protocol.h"

class FlyWestonClient : public QObject
{
    Q_OBJECT
public:
    FlyWestonClient(QObject *parent=NULL);
    //~FlyWestonClient();

    void quit();

    bool isValid();

public slots: 
    WId activeWindow();
    //minimizeWindow();     //TODO: need?
    //unminimizeWindow();   //TODO: need?
    //raiseWindow();        //TODO: need? see forceActiveWindow()
    void forceActiveWindow(WId surface);
    //setState();           //TODO: need?
    //setStrut();           //don't need, see panels
    //setExtendedStrut();   //don't need, see panels
    //icon();               //TODO: need? - never, no protocols to support this 

    void closeWindow(WId surface);

    bool setPanel(QWindow *w, unsigned int pos, int height);

    bool setBackground(QWindow *w);

    void shootWindow(WId surface,int width,int height, bool sync=false);

    void setDesktopReady();  //to enable show desktop

    void setIdleTime(int);
    void setLockWindow(QWindow *w);
    void unlock();
    void lock(); //force lock

    //opacity in percents, i.e. 100 - fully opaque, don't set it in windowAdded()
    void setOpacity(WId surface, unsigned int opacity); 

signals:
    //void windowConfigure(     WId surface,int width,int height);
    void idleTimeout();
    void lockStarted();
    void windowAdded(         WId surface, pid_t pid, int width,int height, const char *title, const char *appid);
    void windowRemoved(       WId surface, pid_t pid);
    void activeWindowChanged( WId surface, pid_t pid, const char *title, const char *appid);
    void windowScreenShotDone(WId surface, void *data, int width, int height);
    void hotkeyActivated(Qt::Key k);

private:
    class Private; 
    Private * d;
};
#endif
